<?php

// Add custom field to the USER page, with name Name of type text and edit value in $name[$exte]
$custom_field['user']['Name']['text']='name';

function hotdesk_update_conf() {
    // Run update_conf.php in order to populate buttons and groups if needed
    $base_plugin_path = substr(dirname(__FILE__),0,strrpos(dirname(__FILE__),"/"));
    $confini = parse_ini_file($base_plugin_path."/configonreload/configonreload.ini");
    exec($confini['scriptReload']);
}

function hotdesk_edit_user($data) {
    global $db, $astman, $conf;

    $itemid = $data['itemid'];
    $query  = "SELECT exten FROM fop2users WHERE id='$itemid'";
    $res    = $db->consulta($query);

    if($res) {
        if($db->num_rows($res)>0) {
            $mirow = $db->fetch_row($res);
            $exten = $mirow[0];

            $values=array();
            $values[] = $data['Name'];
            $values[] = $exten;

            $query = "SELECT dial FROM devices WHERE id='%s' AND dial LIKE 'CUSTOM%%'";
            $res = $db->consulta($query,$exten);
            if($db->num_rows($res)>0) {
                // only update if dial is of type custom

                $query = "UPDATE devices SET description='%s' WHERE id='%s'";
                $db->consulta($query,$values);

                $query = "UPDATE users SET name='%s' WHERE extension='%s'";
                $db->consulta($query,$values);

                if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
                    unset($astman);
                }

                if ($astman) {
                    $astman->database_put("AMPUSER/".$exten,"cidname",$data['Name']);
                    $astman->database_put("AMPUSER/".$exten,"cidnum",$exten);
                }
                hotdesk_update_conf();
            }
            return true;
        }
    }
}

function hotdesk_add_user($data) {
    global $db,$astman,$conf;

    if($data['Name']<>'') {
        // Only insert if name is NOT empty when adding
        $values=array();
        $query = "INSERT INTO devices (id,tech,dial,devicetype,user,description) VALUES('%s','%s','%s','%s','%s','%s')";
        $values[] = $data['userid'];
        $values[] = 'custom';
        $values[] = 'CUSTOM/'.$data['userid'];
        $values[] = 'fixed';
        $values[] = $data['userid'];
        $values[] = $data['Name'];
        $db->consulta($query,$values);

        $values=array();
        $query = "INSERT INTO users (extension,password,name,voicemail,ringtimer,noanswer,recording,outboundcid,sipname,mohclass) VALUES ('%d','%d','%s','novm',0,'','out=Adhoc|in=Adhoc','','','default')";
        $values[] = $data['userid'];
        $values[] = $data['userid']."xxx";
        $values[] = $data['Name'];
        $db->consulta($query,$values);

        if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
            unset($astman);
        }

        if ($astman) {
            $astman->database_put("AMPUSER/".$data['userid'],"cidname",$data['Name']);
            $astman->database_put("AMPUSER/".$data['userid'],"cidnum",$data['userid']);
            $astman->database_put("AMPUSER/".$data['userid'],"device",$data['userid']);
            $astman->database_put("AMPUSER/".$data['userid'],"language",'');
            $astman->database_put("AMPUSER/".$data['userid'],"noanswer",'');
            $astman->database_put("AMPUSER/".$data['userid'],"outboundcid",'');
            $astman->database_put("AMPUSER/".$data['userid'],"recording",'out=Adhoc|in=Adhoc');
            $astman->database_put("CW",$data['userid'],"DISABLED");
        }
    }
    hotdesk_update_conf();
    return true;
}

function hotdesk_del_user($data) {
    global $db, $astman, $conf;

    $id = intval($data['exten']);

    $query = "SELECT dial FROM devices WHERE id='%s' AND dial LIKE 'CUSTOM%%'";
    $res = $db->consulta($query,$id);
    if($db->num_rows($res)>0) {
        // Only remove if type CUSTOM
 
        $query = "DELETE FROM devices WHERE id = '$id'";
        $db->consulta($query);
        $query = "DELETE FROM users WHERE extension = '$id'";
        $db->consulta($query);

        if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
            unset($astman);
        }

        if ($astman) {
            $astman->database_del("AMPUSER/".$id,"cidname");
            $astman->database_del("AMPUSER/".$id,"cidnum");
            $astman->database_del("AMPUSER/".$id,"device");
            $astman->database_del("AMPUSER/".$id,"language");
            $astman->database_del("AMPUSER/".$id,"noanswer");
            $astman->database_del("AMPUSER/".$id,"outboundcid");
            $astman->database_del("AMPUSER/".$id,"recording");
            $astman->database_del("CW/",$id);
        }

    hotdesk_update_conf();
    }
    return true;
}

function hotdesk_profiles_dashboard_widget($name,$link,$icon) {
    $count = 0;
    $ini_array = parse_ini_file("plugins/hotdesk/hotdesk.ini",true);
    foreach($ini_array as $key => $data) {
        if(is_array($data)) {
            $count++;
        }
    }
    draw_dashboard_widget(_dgettext('hotdesk',$name),$link,$icon,$count);
}
